//
//  HDArray.cpp
//  MyObjectFramework
//
//  Created by 한 도영 on 12. 11. 3..
//  Copyright (c) 2012년 한 도영. All rights reserved.
//

#include "HDArray.h"
#include "HDException.h"

HDArray::HDArray(int len): len(len)
{
    this->arr = new HDObject*[len];
}
HDArray::~HDArray()
{
    if (this->arr)
        delete[] this->arr;
}

void HDArray::addObject(HDObject *object)
{
    int i;
    HDObject **tarr = new HDObject*[len+1];
    
    for (i=0; i<len; ++i)
        tarr[i] = this->arr[i];
    
    tarr[len++] = object;
    delete[] this->arr;
    this->arr = tarr;
}
void HDArray::removeObjectAtIndex(int index)
{
    int i;
    try
    {
        if (!isIndexInRange(index))
            throw "Invalid index error occurred";
        
        HDObject *del = this->arr[index];
        
        --(this->len);
        for (i=index; i<this->len; ++i)
            this->arr[i] = this->arr[i+1];
        
        delete del;
    }
    catch (HDException exception)
    {
        cout<<exception<<endl;
    }
}
HDObject& HDArray::objectAtIndex(int index)
{
    if (!arr[index])
        throw "Invalid object is in this array";
    return *arr[index];
}

bool HDArray::isIndexInRange(int index) const
{
    return (index<0 || len+1<index);
}